题目描述
某校开展了同学们喜闻乐见的阳光长跑活动。为了能“为祖国健康工作五十年”,同学们纷纷离开寝室,离开教室,离开实验室,到操场参加3000米长跑运动。一时间操场上熙熙攘攘,摩肩接踵,盛况空前。
为了让同学们更好地监督自己,学校推行了刷卡机制。
学校中有n个地点,用1到n的整数表示,每个地点设有若干个刷卡机。
有以下三类事件:
1、修建了一条连接A地点和B地点的跑道。
2、A点的刷卡机台数变为了B。
3、进行了一次长跑。问一个同学从A出发,最后到达B最多可以刷卡多少次。具体的要求如下:
当同学到达一个地点时,他可以在这里的每一台刷卡机上都刷卡。但每台刷卡机只能刷卡一次,即使多次到达同一地点也不能多次刷卡。
为了安全起见,每条跑道都需要设定一个方向,这条跑道只能按照这个方向单向通行。最多的刷卡次数即为在任意设定跑道方向,按照任意路径从A地点到B地点能刷卡的最多次数。
输入
输入的第一行包含两个正整数n,m,表示地点的个数和操作的个数。
第二行包含n个非负整数,其中第i个数为第个地点最开始刷卡机的台数。
接下来有m行,每行包含三个非负整数P,A,B,P为事件类型,A,B为事件的两个参数。
最初所有地点之间都没有跑道。
每行相邻的两个数之间均用一个空格隔开。表示地点编号的数均在1到n之间,每个地点的刷卡机台数始终不超过10000,P=1,2,3。
输出
输出的行数等于第3类事件的个数,每行表示一个第3类事件。如果该情况下存在一种设定跑道方向的方案和路径的方案,可以到达,则输出最多可以刷卡的次数。如果A不能到达B,则输出-1。
样例输入
9 31
10 20 30 40 50 60 70 80 90
3 1 2
1 1 3
1 1 2
1 8 9
1 2 4
1 2 5
1 4 6
1 4 7
3 1 8
3 8 8
1 8 9
3 8 8
3 7 5
3 7 3
1 4 1
3 7 5
3 7 3
1 5 7
3 6 5
3 3 6
1 2 4
1 5 5
3 3 6
2 8 180
3 8 8
2 9 190
3 9 9
2 5 150
3 3 6
2 1 210
3 3 6
样例输出
-1
-1
80
170
180
170
190
170
250
280
280
270
370
380
580
题解
LCT+并查集
首先考虑答案是什么:如果图是一个森林的话,那么答案显然是两点之间路径上的点权之和。
如果不是森林的话,考虑把每个边双缩成一个点,只要到达这个边双各种的任意一个点即可全部到达。所以答案为两点之间路径上所有边双的点权之和。
所以只需要动态维护边双即可。
考虑到没有删除操作,所以可以使用并查集维护每个点所在的边双。同时使用LCT维护树的形态结构。
具体地,对于每个加边操作,如果它们不在同一个边双里且未连通,则把它们所在边双连上。否则如果它们不在同一个边双里且已经连通,则需要提取它们之间的路径,把路径上的点所在边双全部改为新的边双并在LCT中“删除”这些点。这个过程可以直接对Splay Tree进行dfs实现,并使用并查集来维护。
同时因为使用并查集“删点”,所以在查询父亲时需要在并查集中find。
修改和查询操作和普通的LCT相同。
总的时间复杂度为常数巨大的$O((n+m)log n)$。亲测必须使用并查集维护森林的连通性而非LCT中的findroot函数,以及加上读入优化才可以过(出题人卡常数丧心病狂= =)
#include <cstdio> #include <cstring> #include <algorithm> #define N 150010 using namespace std; int v[N] , f[N] , fa[N] , c[2][N] , w[N] , sum[N] , rev[N] , con[N]; int find(int x) { return x == f[x] ? x : f[x] = find(f[x]); } int fc(int x) { return x == con[x] ? x : con[x] = fc(con[x]); } void pushup(int x) { sum[x] = sum[c[0][x]] + sum[c[1][x]] + w[x]; } void pushdown(int x) { if(rev[x]) swap(c[0][x] , c[1][x]) , rev[c[0][x]] ^= 1 , rev[c[1][x]] ^= 1 , rev[x] = 0; } bool isroot(int x) { return c[0][find(fa[x])] != x && c[1][find(fa[x])] != x; } void update(int x) { if(!isroot(x)) update(find(fa[x])); pushdown(x); } void rotate(int x) { int y = find(fa[x]) , z = find(fa[y]) , l = (c[1][y] == x) , r = l ^ 1; if(!isroot(y)) c[c[1][z] == y][z] = x; fa[x] = z , fa[y] = x , fa[c[r][x]] = y , c[l][y] = c[r][x] , c[r][x] = y; pushup(y) , pushup(x); } void splay(int x) { update(x); while(!isroot(x)) { int y = find(fa[x]) , z = find(fa[y]); if(!isroot(y)) rotate((c[0][y] == x) ^ (c[0][z] == y) ? x : y); rotate(x); } } void access(int x) { int t = 0; while(x) splay(x) , c[1][x] = t , pushup(x) , t = x , x = find(fa[x]); } void makeroot(int x) { access(x) , splay(x) , rev[x] ^= 1; } void link(int x , int y) { makeroot(x) , fa[x] = y; } void split(int x , int y) { makeroot(x) , access(y) , splay(y); } void cut(int x , int y) { split(x , y) , c[0][y] = fa[x] = 0 , pushup(y); } void dfs(int x , int y) { f[x] = y; pushdown(x); if(c[0][x]) dfs(c[0][x] , y); if(c[1][x]) dfs(c[1][x] , y); } inline int read() { int ret = 0; char ch = getchar(); while(ch < '0' || ch > '9') ch = getchar(); while(ch >= '0' && ch <= '9') ret = (ret << 3) + (ret << 1) + ch - '0' , ch = getchar(); return ret; } int main() { int n , m , i , opt , x , y , tx , ty; n = read() , m = read(); for(i = 1 ; i <= n ; i ++ ) sum[i] = w[i] = v[i] = read() , f[i] = con[i] = i; for(i = 1 ; i <= m ; i ++ ) { opt = read() , x = read() , y = read() , tx = find(x); if(opt != 2) ty = find(y); if(opt == 1) { if(tx != ty) { if(fc(tx) != fc(ty)) link(tx , ty) , con[con[tx]] = con[ty]; else split(tx , ty) , w[ty] = sum[ty] , dfs(ty , ty) , c[0][ty] = 0; } } else if(opt == 2) splay(tx) , w[tx] += y - v[x] , sum[tx] += y - v[x] , v[x] = y; else if(fc(tx) != fc(ty)) puts("-1"); else split(tx , ty) , printf("%d " , sum[ty]); } return 0; }